## GridX Overview

#### **A fast rendering, well modularized and plugin architecture based Grid.**

Besides supporting a rich set of popular features, GridX is optimized and extremely capable of supporting huge dataset(e.g.[larger than millions of rows](http://evanhw.github.com/gridx/gridx/tests/test_grid_huge_data.html)).

GridX is consisted of:

* A compact and lightweight core
* A flexible plugin machinery with comprehensive module life-cycle and conflict management
* A rich and extend-able set of modules which can be loaded on demand.

GridX is available under [Dojo Toolkit](http://dojotoolkit.org/) [CLA](http://dojofoundation.org/about/cla) with the same [BSD/AFLv2 license] (http://dojotoolkit.org/license)

## Installation

1.  [CPM installation](https://github.com/kriszyp/cpm) with the following command:

    ``cpm install gridx``

2.  Manual installation by putting GridX at the same level as Dojo, e.g:
 * dojo 
 * dijit
 * dojox
 * gridx

GridX works best with [Dojo 1.7.2](http://download.dojotoolkit.org/release-1.7.2/) or higher.


## Quick ways to know GridX

* [Feature Coverage](https://docs.google.com/spreadsheet/pub?key=0AgR1KOpszcsZdF9ZbW5hWFdYUFAzdjdhZi1xcGMwUVE&gid=1)
* [Module Compatibility Matrix](https://docs.google.com/spreadsheet/pub?key=0AgR1KOpszcsZdF9ZbW5hWFdYUFAzdjdhZi1xcGMwUVE&gid=0)
* [Demo gallery](http://evanhw.github.com/gridx/gridx/gallery/gallery.html)
* [Benchmaks]() (in progress)
* [Tutorial](https://github.com/evanhw/gridx/wiki/Introduction-to-Gridx) (in progress)
* [API Doc](http://evanhw.github.com/gridx/doc/gridx.html) (in progress)
* [Known limitations]() (in progress)
* [Release download](https://github.com/evanhw/gridx/zipball/master)
* [Report bugs](https://github.com/evanhw/gridx/issues/new)


## GridX Home Site (in progress)
Please check out [GridX Home Site]() for more details on how GridX can help you.


## GridX Team
* Xiao Wen Zhu (Oliver) - IBM, CCLA
* Pei Wang (Nate) - IBM, CCLA
* Wei Huang (Evan) -  Dojo Committer

Please contact [Wei Huang (Evan)](mailto:evanhuangwei@gmail.com) if you have got any questions. We really appreciate any suggestions or fix patches to improve GridX.
